// JavaScript Document
var cs;
var cc;

var cW;
var cH;

var prevU;
var prevA;
var prevB;

//図の数値
//矩形
var rectU;
var frameU;

//円
var circleA;
var circleB;
var commonA;
var commonB;
//縁
var arcA;
var arcB;


//各記号
var tU;
var tA;
var tB;

var form;

var type;

var strU;
var strA;
var strB;
var strAB;

var selectName;

//個別に設定するコンテンツの高さ
function getContentHeight()
{
	return 650;
}

function loadContentHandler()
{
	try
	{
		//スマートフォン
		var ua = navigator.userAgent;
		if(ua.indexOf('iPhone') > 0 || ua.indexOf('iPod') > 0 || ua.indexOf('Android') > 0 && ua.indexOf('Mobile') > 0)
		{
			browse = true;
		}
		//タブレット
		else if(ua.indexOf('iPad') > 0 || ua.indexOf('Android') > 0)
		{
			browse = true;
		}
		else
		{
			browse = false;
		}
		
		cc = document.getElementById("contentCanvas");
		cs = new createjs.Stage(cc);
		createjs.Touch.enable(cs);
			
		cW = 380;
		cH = 320;
		
		prevU = 20;
		prevA = 2;
		prevB = 3;
		
		document.getElementById("text0").value = prevU;
		document.getElementById("text1").value = prevA;
		document.getElementById("text2").value = prevB;
		
		document.getElementById("windowBlock").style.textAlign="left";
		document.getElementById("windowBlock").style.marginRight = "10px";
		document.getElementById("windowBlock").style.width = "450px";
		
		document.getElementById("content").style.marginLeft = "10px";
		
		document.getElementById("resetBtn").style.marginTop = "20px";
		document.getElementById("resetBtn").addEventListener("click", resetHandler);
		
		document.getElementById("text0").addEventListener("input", inputHandler);
		document.getElementById("text1").addEventListener("input", inputHandler);
		document.getElementById("text2").addEventListener("input", inputHandler);
		
		document.getElementById("upBtn0").addEventListener("click", changeDataHandler);
		document.getElementById("downBtn0").addEventListener("click", changeDataHandler);
		document.getElementById("upBtn1").addEventListener("click", changeDataHandler);
		document.getElementById("downBtn1").addEventListener("click", changeDataHandler);
		document.getElementById("upBtn2").addEventListener("click", changeDataHandler);
		document.getElementById("downBtn2").addEventListener("click", changeDataHandler);
		
		document.getElementById("eventBalloon").addEventListener("click", selectBalloonHandler);
		
		$(".buttonFront").css("vertical-align", "middle");
		
		$(".denom").css("line-height", "1.1em");
		$(".numer").css("line-height", "1.1em");
		
		//図の設定
		//矩形
		rectU = new createjs.Shape();
		rectU.name = "rectU";
		cs.addChild(rectU);
		
		//矩形の縁
		frameU = new createjs.Shape();
		cs.addChild(frameU);
		
		//集合の円
		circleA = new createjs.Shape();
		circleA.name = "circleA";
		cs.addChild(circleA);
		circleB = new createjs.Shape();
		circleB.name = "circleB";
		cs.addChild(circleB);
		commonA = new createjs.Shape();
		commonA.name = "commonA";
		cs.addChild(commonA);
		commonB = new createjs.Shape();
		cs.addChild(commonB);
		commonA.mask = commonB;
		
		//円の縁
		arcA = new createjs.Shape();
		cs.addChild(arcA);
		arcB = new createjs.Shape();
		cs.addChild(arcB);
		
		//記号
		tU = new createjs.Text("U", "italic 28px Times New Roman");
		cs.addChild(tU);
		tU.x = 63;
		tU.y = 18;
		
		tA = new createjs.Text("A", "italic 28px Times New Roman");
		cs.addChild(tA);
		tA.x = 75;
		tA.y = 65;
		
		tB = new createjs.Text("B", "italic 28px Times New Roman");
		cs.addChild(tB);
		tB.x = 280;
		tB.y = 65;
		
		form = new createjs.Container();
		var a = new createjs.Text("A", "italic 28px Times New Roman");
		var b = new createjs.Text("B", "italic 28px Times New Roman");
		var s = new createjs.Text("∩", "28px Times New Roman");
		form.addChild(a);
		s.x = form.getBounds().width;
		form.addChild(s);
		b.x = form.getBounds().width;
		form.addChild(b);
		var f = new createjs.Shape();
		f.name = "fill";
		f.graphics.setStrokeStyle(0);
		f.graphics.beginFill("rgba(255, 255, 255, 0.05)");
		f.graphics.drawRect(0, 0, form.getBounds().width, form.getBounds().height);
		f.graphics.endStroke();
		form.addChild(f);
		cs.addChild(form);
		form.x = 20;
		form.y = 280;
		
		circleA.addEventListener("mousedown", selectEventHandler);
		circleB.addEventListener("mousedown", selectEventHandler);
		commonA.addEventListener("mousedown", selectEventHandler);
		rectU.addEventListener("mousedown", selectEventHandler);
		
		form.addEventListener("mousedown", changeTypeHandler);
		
		type = 0;
		
		selectName = "";
		
		changeNumberHandler();
		
		changeCanvas();
		
		cs.update();
		
		checkVersionHandler("1.1.0");
	}
	catch(e)
	{
		alert("loadContentHandler:" + e.toString());
	}
}

function selectBalloonHandler(e)
{
	hideBalloon();
}

function changeTypeHandler()
{
	try
	{
		hideBalloon();
	
		if(type == 0)
		{
			type = 1;
		}
		else
		{
			type = 0;
		}

		changeCanvas();

		cs.update();
	}
	catch(e)
	{
		alert("changeTypeHandler:" + e.toString());
	}
}

function inputHandler(e)
{
	try
	{
		var f = false;
	
		if(e.target.value != "")
		{
			var n = Number(e.target.value);
			
			if(e.target.id == "text0")
			{
				if(n < Math.max(prevA, prevB))
				{
					alert("各事象の値を含む値を入力してください。");
				}
				else
				{
					prevU = n;
					f = true;
				}
				
				document.getElementById("text0").value = prevU;
			}
			else if(e.target.id == "text1")
			{
				if(n >0 && n<= prevU)
				{
					prevA = n;
					f = true;
				}
				else
				{
					alert("全事象U内の値を入力してください。");
				}
				
				document.getElementById("text1").value = prevA;
			}
			else
			{
				if(n >0 && n<= prevU)
				{
					prevB = n;
					f = true;
				}
				else
				{
					alert("全事象U内の値を入力してください。");
				}
				
				document.getElementById("text2").value = prevB;
			}
		}
		
		if(f)
		{
			changeNumberHandler();
		}
	}
	catch(e)
	{
		alert("inputHandler:" + e.toString());
	}
}

function changeNumberHandler()
{
	try
	{
		var i=1;
		var dA=0;
		var dB=0;
		var dAB=0;
		
		strA="なし";
		strB="なし";
		strAB="なし";
		strU="";
		
		for(i=1; i<=prevU; i++)
		{
			if(i==1)
			{
				strU = "1";
			}
			else
			{
				strU = strU + ", " + i;
			}
		}
		
		i=1;
		while(true)
		{
			if(i*prevA <= prevU)
			{
				if(i==1)
				{
					strA = prevA;
				}
				else
				{
					strA = strA + ", " + i*prevA;
				}
			
				dA+=1;
				i++;
			}
			else
			{
				break;
			}
		}
		
		i=1;
		while(true)
		{
			if(i*prevB <= prevU)
			{
				if(i==1)
				{
					strB = prevB;
				}
				else
				{
					strB = strB + ", " + i*prevB;
				}
			
				dB+=1;
				i++;
			}
			else
			{
				break;
			}
		}
		
		//最小公倍数
		var pAB = (prevA * prevB)/getGCD(prevA, prevB);
		i=1;
		while(true)
		{
			if(i*pAB <= prevU)
			{
				if(i==1)
				{
					strAB = pAB;
				}
				else
				{
					strAB = strAB + ", " + i*pAB;
				}
			
				dAB+=1;
				i++;
			}
			else
			{
				break;
			}
		}
		
		for(var i=0; i<=7; i++)
		{
			if(i <= 2)
			{
				document.getElementById("eA"+i).innerHTML = dA;
				document.getElementById("eB"+i).innerHTML = dB;
				if(i==0)
				{
					document.getElementById("eAB"+i+"_1").innerHTML = dAB;
				}
				else
				{
					document.getElementById("eAB"+i).innerHTML = dAB;
				}
			}
			
			document.getElementById("eU"+i).innerHTML = prevU;
		}
		
		document.getElementById("eAB0_0").innerHTML = pAB;
		
		document.getElementById("result").innerHTML = dA+dB-dAB;
	}
	catch(e)
	{
		alert("changeNumberHandler:" + e.toString());
	}
}

//最大公約数
function getGCD(a, b)
{
	if (b == 0)
	{
		return a;
	}
	else
	{
		return getGCD(b, a % b);
	}
}

function selectEventHandler(e)
{
	try
	{
		if(document.getElementById("eventBalloon").style.display == "none"
		|| selectName != e.target.name)
		{
			document.getElementById("eventBalloon").style.display = "block";
			
			var p = $("#contentCanvas").position();
			
			var sX = p.left;
			var sY = p.top;
			
			selectName = e.target.name;
			
			if(e.target.name == "circleA")
			{
				sX += -10;
				sY += 240;
				
				document.getElementById("eventData").innerHTML = strA;
			}
			else if(e.target.name == "circleB")
			{
				sX += 105;
				sY += 230;
				
				document.getElementById("eventData").innerHTML = strB;
			}
			else if(e.target.name == "commonA")
			{
				sX += 55;
				sY += 215;
				
				document.getElementById("eventData").innerHTML = strAB;
			}
			else
			{
				sX += 55;
				sY += 277;
				
				document.getElementById("eventData").innerHTML = strU;
			}
			
			document.getElementById("eventBalloon").style.display = "block";
			document.getElementById("eventBalloon").style.left = sX + "px";
			document.getElementById("eventBalloon").style.top = sY + "px";
		}
		else
		{
			document.getElementById("eventBalloon").style.display = "none";
		}
			
	}
	catch(e)
	{
		alert("selectEventHandler:" + e.toString());
	}
}

function changeDataHandler(e)
{
	try
	{
		hideBalloon();
	
		var f = -1;
		
		switch(e.target.id)
		{
			case "upBtn0":
				prevU += 1;
				document.getElementById("text0").value = prevU;
				f = 0;
				break;
			case "upBtn1":
				if(prevA+1 <= prevU)
				{
					prevA += 1;
					document.getElementById("text1").value = prevA;
					f = 1;
				}
				break;
			case "upBtn2":
				if(prevB+1 <= prevU)
				{
					prevB += 1;
					document.getElementById("text2").value = prevB;
					f = 2;
				}
				break;
			case "downBtn0":
				if(prevU-1 >= Math.max(prevA, prevB))
				{
					prevU -= 1;
					document.getElementById("text0").value = prevU;
					f = 0;
				}
				break;
			case "downBtn1":
				if(prevA-1 > 0)
				{
					prevA -= 1;
					document.getElementById("text1").value = prevA;
					f = 1;
				}
				break;
			case "downBtn2":
				if(prevB-1 > 0)
				{
					prevB -= 1;
					document.getElementById("text2").value = prevB;
					f = 2;
				}
				break;
		}
		
		//変更がある場合
		if(f >= 0)
		{
			changeNumberHandler();
		}
	}
	catch(e)
	{
		alert("changeDataHandler:" + e.toString());
	}
}

function hideBalloon()
{
	document.getElementById("eventBalloon").style.display = "none";
}

function changeModeHandler(e)
{
	try
	{
		var index = parseInt(e.currentTarget.id.substring(6, 7));
		
		if(!e.currentTarget.checked)
		{
			index--;
		}
		
		for(var i=0; i<=1; i++)
		{
			if(i<=index)
			{
				document.getElementById("gCheck"+i).checked = true;
			}
			else
			{
				document.getElementById("gCheck"+i).checked = false;
			}
		}
		
		type = index;
		
		cs.update();
	}
	catch(e)
	{
		alert("changeModeHandler:" + e.toString());
	}
}

function openOptionHandler(e)
{
	try
	{
		var t;
		
		switch(e.target.id)
		{
			case "option0":
				document.getElementById("selectData").innerHTML = '<span class="times">U</span>';
				document.getElementById("addSpan0").innerHTML = "100以下の自然数";
				t = 0;
				break;
			case "option1":
				document.getElementById("selectData").innerHTML = '<span class="times">A</span>';
				document.getElementById("addSpan0").innerHTML = "100以下の8の倍数";
				t = 1;
				break;
		}
		
		var i;
		var s;
		var str = "";
		
		
		if(t == 0)
		{
			for(i=1; i<=100; i++)
			{
				if(i == 1)
				{
					str = 1;
				}
				else
				{
					str = str + ", " + i.toString();
				}
			}
		}
		else
		{
			for(i=8; i<=100; i+=8)
			{
				if(i == 8)
				{
					str = "8";
				}
				else
				{
					str = str + ", " + i.toString();
				}
			}
		}
		
		document.getElementById("addSpan1").innerHTML = str;
		//式の値を設定
		showModal('optionBlock');
	}
	catch(e)
	{
		alert("openOptionHandler:" + e.toString());
	}
}

function closeModalHandler(e)
{
	try
	{
		//オプションを閉じる
		closeModal();

	}
	catch(e)
	{
		alert('closeModalHandler:' + e.toString());
	}
}

function changeDisplayHandler()
{
	try
	{
		
		
		changeCanvas();
	}
	catch(e)
	{
		alert("changeDisplayHandler:" + e.toString());
	}
}

function changeCanvas()
{
	try
	{
		
		var fColor;
		var arcColor;
		var rectFill;
		var circleFillA;
		var circleFillB;
		var circleFillAB;
		
		if(type == 0)
		{
			rectFill = "rgba(255, 255, 255, 1)";
			
			circleFillA = "rgba(247,199,89, 0.4)";
			circleFillB = "rgba(247,199,89, 0.4)";
			circleFillAB = "rgba(247,199,89, 0.4)";
		}
		else
		{
			rectFill = "rgba(255, 255, 255, 1)";
			
			circleFillA = "#D5E8C2";
			circleFillB = "#D2ECFB";
			circleFillAB = "#FBDAD8";
		}
		
		frameU.graphics.clear();
		frameU.graphics.setStrokeStyle(1);
		frameU.graphics.beginStroke("#000000");
		frameU.graphics.moveTo(60, 30);
		frameU.graphics.lineTo(20, 30);
		frameU.graphics.lineTo(20, 270);
		frameU.graphics.lineTo(360, 270);
		frameU.graphics.lineTo(360, 30);
		frameU.graphics.lineTo(90, 30);
		frameU.graphics.endStroke();
		
		arcA.graphics.clear();
		arcA.graphics.setStrokeStyle(2);
		arcA.graphics.beginStroke("#000000");
		arcA.graphics.arc(140, 150, 90, -118 * Math.PI/180, -139 * Math.PI/180, false);
		arcA.graphics.endStroke();
		
		arcB.graphics.clear();
		arcB.graphics.setStrokeStyle(2);
		arcB.graphics.beginStroke("#000000");
		arcB.graphics.arc(250, 150, 80, -70 * Math.PI/180, -52 * Math.PI/180, true);
		arcB.graphics.endStroke();
		
		circleA.graphics.clear();
		circleA.graphics.setStrokeStyle(0);
		circleA.graphics.beginFill(circleFillA);
		circleA.graphics.drawCircle(140, 150, 90);
		circleA.graphics.endFill();
		circleA.graphics.endStroke();
		
		circleB.graphics.clear();
		circleB.graphics.setStrokeStyle(0);
		circleB.graphics.beginFill(circleFillB);
		circleB.graphics.drawCircle(250, 150, 80);
		circleB.graphics.endFill();
		circleB.graphics.endStroke();
		
		commonA.graphics.clear();
		commonA.graphics.setStrokeStyle(0);
		commonA.graphics.beginFill(circleFillAB);
		commonA.graphics.drawCircle(140, 150, 90);
		commonA.graphics.endFill();
		commonA.graphics.endStroke();
		
		commonB.graphics.clear();
		commonB.graphics.setStrokeStyle(0);
		commonB.graphics.beginFill("rgba(0, 0, 0, 0)");
		commonB.graphics.drawCircle(250, 150, 80);
		commonB.graphics.endFill();
		commonB.graphics.endStroke();
		
		
		rectU.graphics.clear();
		rectU.graphics.setStrokeStyle(0);
		rectU.graphics.beginFill(rectFill);
		rectU.graphics.drawRect(20, 30, 340, 240);
		rectU.graphics.endFill();
		
		tU.color = fColor;
		tA.color = arcColor;
	}
	catch(e)
	{
		alert("changeCanvas:" + e.toString());
	}
}

function saveContent()
{
	try
	{
		var array = [];
		
		array[0] = [];
		
		array[0][0] = prevU;
		array[0][1] = prevA;
		array[0][2] = prevB;
		
		array[1] = [];
		
		array[1][0] = document.getElementById("text0").value;
		array[1][1] = document.getElementById("text1").value;
		array[1][2] = document.getElementById("text2").value;
		
		array[2] = type;
		
		array[3] = [];
		
		array[3][0] = selectName;
		array[3][1] = document.getElementById("eventBalloon").style.display;
		array[3][2] = document.getElementById("eventBalloon").style.left;
		array[3][3] = document.getElementById("eventBalloon").style.top;
		
		return array;
	}
	catch(e)
	{
		alert("saveContent:" + e.toString());
	}
}

function loadContent(array)
{
	try
	{
		prevU = array[0][0];
		prevA = array[0][1];
		prevB = array[0][2];
		
		document.getElementById("text0").value = array[1][0];
		document.getElementById("text1").value = array[1][1];
		document.getElementById("text2").value = array[1][2];
		
		type = array[2];
		
		changeNumberHandler();
		
		selectName = array[3][0];
		
		if(selectName == "circleA")
		{
			document.getElementById("eventData").innerHTML = strA;
		}
		else if(selectName == "circleB")
		{
			document.getElementById("eventData").innerHTML = strB;
		}
		else if(selectName == "commonA")
		{
			document.getElementById("eventData").innerHTML = strAB;
		}
		else if(selectName == "rectU")
		{
			document.getElementById("eventData").innerHTML = strU;
		}
		
		document.getElementById("eventBalloon").style.display = array[3][1];
		document.getElementById("eventBalloon").style.left = array[3][2];
		document.getElementById("eventBalloon").style.top = array[3][3];
		
		changeCanvas();
		
		cs.update();
	}
	catch(e)
	{
		alert("loadContent:" + e.toString());
	}
}



function resetHandler(e)
{
	try
	{
		hideBalloon();
		
		type = 0;
		
		prevU = 20;
		prevA = 2;
		prevB = 3;
		
		document.getElementById("text0").value = prevU;
		document.getElementById("text1").value = prevA;
		document.getElementById("text2").value = prevB;
		
		changeNumberHandler();
		
		changeCanvas();
		
		cs.update();
	}
	catch(e)
	{
		alert("resetHandler:" + e.toString());
	}
}